#ifndef __NNESTIMATOR_H
#define __NNESTIMATOR_H

#include <fstream>
#include <vector>

using namespace std;

class NNEstimator {
public:
	vector<float*> inds_dists_nn;
	vector<float*> sampleDb;
	const char* dir;
	ofstream LOG;
	int sampleSize;
	int db_pages;
	int page_size;
	int ts_sizeconstant;
	int ts_size;
	int dist_type;

public:
	NNEstimator(const char* dir, int db_pages, int dist_type);
	~NNEstimator();
	void loadInds();
	void loadExamples();
	void computeNNDists();

private:
	float* readExample(char* cline);
	void setTsSize(char* cline);
	void loadSample(int pageNum, int& position, int& linecounter);
	void loadDB(vector<float*>& DB, int pageNum);
	void NNEstimator::logNbs();
	void updateNNbs(vector<float*> &DB, int offset);
	double nnDist(float* x, float* y, bool earlyAbandon, double minDist);
};

#endif