#ifndef __DISCDISCORDS_H
#define __DISCDISCORDS_H

#include "main_memory.h"
#include <fstream>

class DiscDiscords {

public: 
	const char* dir;
	double threshold;
	int db_pages;
	int page_size;
	int ts_len;
	int k_disc; //max. number of discords to find
	int dist_type;
	MainMemory* mainMem;
	vector <float*> discords;
	vector <int> discord_indxPtrs;
	vector <int> avr_comparisons;
	vector <float> discord_nndists;
	vector <float> nn_dists;
	vector <int> nnbs; 

	ofstream LOG;
	ofstream MEMLOG;
	ofstream DISCORDSLOG;
	ofstream DISCINDSLOG;

public:
	DiscDiscords(const char* dir, int k_discords, double threshold, 
				 int db_pages, int dist_type, int page_size=-1, int ts_len=-1);
	~DiscDiscords();
	void findDiscords();

private:
	void buildMemory();
	void loadDB(vector<float*>& DB, int pageNum);
	void updateNNbs(vector<float*> &DB, int offset);
	double nnDist(float* x, float* y, bool earlyAbandon, double minDist);
	void selectTopDiscords();
	void logDiscords();
};

#endif