#include "io_utils.h"
#include <fstream>
#include <string>
#include <iostream>
#include <ctime>

using namespace std;

void read_matrix(vector<float*>& M, string fileName, int& rows, int& cols) {
	FILE* fp = fopen(fileName.c_str(), "r");
	long size = file_size(fp);
	fseek(fp, 0, SEEK_SET);
	char* buf = new char[size];
	fread((void*) buf, sizeof(char), size, fp);
	fclose(fp);

	if (rows == -1) {
		get_rows_cols(buf, size, rows, cols);
	}
	int n = 0;
	char *st, sep[]=" \t\n";
    st=strtok(buf,sep);
	for (int i = 0; i < rows; i++) {
		float* ts = new float[cols];
		for (int j = 0; j < cols; j++) {  
			float l= (float) atof(st);
			st=strtok(NULL,sep);
			ts[j] = l;
		}
		M.push_back(ts);
	}
	delete [] buf;
}

void read_matrix1(vector<float*>& M, string fileName, int& rows, int& cols) {
	//int starttimer = clock();
	FILE* fp = fopen(fileName.c_str(), "r");
	long size = file_size(fp);
	fseek(fp, 0, SEEK_SET);
	char* buf = new char[size];
	fread((void*) buf, sizeof(char), size, fp);
	fclose(fp);
	//int endtimer = clock();
	//double time_spent = (double) (endtimer-starttimer) / (double) 1000;
	//cout << "Time to read one page: " << time_spent << "sec." << endl;

	//starttimer = clock();
	if (rows == -1) {
		get_rows_cols1(buf, size, rows, cols);
	}
	int p = 0;
	for (int i = 0; i < rows; i++) {
		float* ts = new float[cols];
		for (int j = 0; j < cols; j++) {
			while (buf[p] == ' ' || buf[p] == '\t' || buf[p] == '\n') {
				p++;
			}
			int startInd = p;
			int endInd = p;
			while (buf[p] != '\n' && buf[p] != ' ' && buf[p] != '\t') {
				endInd++;
				p++;
			}
			if (endInd > startInd) {
				char strNum[20];
				int q = startInd;
				for (; q < endInd; q++) {
					strNum[q-startInd] = buf[q];
				}
				strNum[endInd - startInd] = 0;
				float l= (float) atof(strNum);
				ts[j] = l;
			}
		}
		M.push_back(ts);
	}
	delete [] buf;
	//endtimer = clock();
	//time_spent = (double) (endtimer-starttimer) / (double) 1000;
	//cout << "Time to parse text data: " << time_spent << "sec." << endl;
}

void get_rows_cols1(const char* buf, int buf_size, int& rows, int& cols) {
	int startInd = 0;
	int endInd = 0;
	int len = 0;
	rows = 0;
	cols = 0;
	int bufLen = (int) strlen(buf);
	for (int i = 0; i < bufLen; i++) {
		endInd = i;
		if (buf[i] == '\n') {
			if (endInd - startInd > 100) {
				rows++;
			}
			startInd = i;
		}
	}
	int p = 0;
	while (buf[p] != '\n') {
		while (buf[p] == ' ' || buf[p] == '\t') {
			p++;
		}
		bool isColumn = false;
		while (buf[p] != '\n' && buf[p] != ' ' && buf[p] != '\t') {
			isColumn = true;
			p++;
		}
		if (isColumn) {
			cols++;
		}
	}
}

void get_rows_cols(const char* buf, int buf_size, int& rows, int& cols) {
	rows = 0;
	cols = 0;
	//necessary as strtok changes the first argument
	char* newbuf = new char[buf_size];
	for (int i = 0; i < buf_size; i++) {
		newbuf[i] = buf[i];
	}

	bool colsCounted = false;
	char *st, *st1, sep1[] = "\n", sep2[] = " \t\n";
	st = strtok(newbuf, sep1);
	char* firstLine;
	double avrLen = 2;
	while (st != NULL) {
		int len = (int) strlen(st);
		if (len < avrLen) {
			st = strtok(NULL, sep1);
			continue;
		}
		if (!colsCounted) {
			firstLine = new char[100000];
			strcpy(firstLine, st);
			colsCounted = true;
			double avr = (double) len / (double) 2;
			avrLen = (avr > 100) ? 100 : avr;
		}
		rows++;
		if (rows == 10000) {
			cout << "dump" << endl;
			cout << "st" << st << endl;
		}
		
		st = strtok(NULL, sep1);
	}
	delete [] newbuf;

	st1 = strtok(firstLine, sep2);
	while(st1 != NULL) {
		st1 = strtok(NULL, sep2);
		cols++;
	}
	delete [] firstLine;
}

long file_size (FILE *f) {
	long cur_pos, length;
	cur_pos = ftell(f);
	fseek(f, 0, SEEK_END); // set pointer to end of file
	length=ftell(f); // offset in bytes from file's beginning
	fseek(f, cur_pos, SEEK_SET); // restore original position
	return length;
}