#ifndef __MAINMEMORY_H
#define __MAINMEMORY_H

#include <vector>
#include "util_malloc.h"
#include <fstream>

using namespace std;
class MainMemory {
public: 
	vector <float*> MM; //main memory container
	vector <int> indxPtr; //indices of the elements that have entered the MM
	vector <int> MMvolume; //the size of the MM after loading each page
	vector <int> avr_comparisons; // avr number of comparisons per page in the DB
	vector <float*> pivots; //pivot points
	vector <float*> pivotDists;// distances of the time series in MM to the pivot points

	const char* dir;
	double threshold;
	int mem_pages;
	int page_size;
	int ts_len;
	int dist_type;
	ofstream* LOG;
	ofstream* MEMLOG;
	ofstream MEMDUMP1;
	ofstream MEMDUMP2;
	bool usePivots;

public:
	MainMemory(const char* dirName, double threshold, int mem_pages, int dist_type, int page_size, int ts_len);
	~MainMemory();
	void buildMemory();

private:
	void loadPivots();
	float* getPivotDists(float* dbEl, bool& failsThreshold);
	void deletePivotDists(float* el_pivotDists);
	void deletePivotDists(int memElId);
	void addPivotDists(float* el_dists);
	void computeSampleNNDists(); // necessary to extract good pivots
	bool farFromPivots(float* el_dists, double threshold);
	bool exceedsPivot(float* el_dists, float* dists, double threshold);
	void buildMainMemory(vector<float*>& DB, int newoffset);
	void loadDB(vector <float*>& DB, int pageNum);
	void dumpMemory();
	double nnDist(float* x, float* y, bool earlyAbandon, double minDist);
};

#endif 